import "Turbine"
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "JackdawPlugins.WardenIndicator.Function"
import "JackdawPlugins.WardenIndicator.Data"

import "Deusdictum.UI.Dragbar" -- I *love* this plugin!

--Concept; After pressing the initial gambit key, an indicator pops up with suggestions under each major category of gambit skill.

--Many thanks to DeusDictum and the author of http://lorebook.lotro.com/wiki/Warden:_Gambits_Sorted_By_Effect where the tables come from!

--[[Unavoidable Issues; 
		Will not detect if a keypress fails, and will then loop continuously under the wrong indicaton until a gambit is used.
		Cannot be used by clickers, only key-pressers, and ones that use a press to activate gambits too, no less.
		Shows Gambits I do not know, but am the right level for.
		Mouse visibility may be an issue when targeting as a tank; so all frames are mouse-invisible, except... the ability icon *is* mouse visible as otherwise - no tooltips!
		I only have a level 23 Warden and so can't test the high level abilities. Well, not an unavoidable issue, but give me time to level!
		
	ToDo:
		Get ready for the patch by cleaning the NASTY HACKS!
		Key binding module not thoroughly tested.
		
	NOTE:
		We have a window, with a listbox. This listbox contains the labels and then sub-listboxes to hold the gambits. The reason there is not just one big listbox is that otherwise the text width messes up.
	]]--
	
--Setting this to "true" shows the frame even when out-of-combat allowing OOC practice, and for testing porpoises. I mean, purposes.

showOOC=false

--Default Height of main frame - Silly small, but that is ok, it resizes later!
height=20


--Greet the Player!
Turbine.Shell.WriteLine("Warden Indicator Here, Sir!")

--Load data
WardenData=Turbine.PluginData.Load( Turbine.DataScope.Character, "WardenIndicator" );
if WardenData==nil then
	WardenData={x=200,y=200,spearkey=268435498,shieldkey=268435506,shoutkey=268435518,gambitkey=268435543,minsize=1,reverse=true,IconSize=32}
	Turbine.Shell.WriteLine("Welcome to Warden Indicator, Sir! Type /WI for options, Sir!")
end

IconSize=WardenData.IconSize

--Reset the gambit table.
LoadRawList()
ResetGambits()

--Register the key-change slash command

shellCommand = Turbine.ShellCommand()
function shellCommand:Execute(command, args)
	if args=="" then
		Turbine.Shell.WriteLine("Please type '/WI Keys' to change the keys and '/WI *length*' to change the minimum length of gambit to show.")
		Turbine.Shell.WriteLine("You can also type '/WI all' to show all possible gambits, Sir, but it may be bigger than the screen.")
		Turbine.Shell.WriteLine("'/WI Size' changes the icon size between three possible variants, sir. You may need to reload the plugin due to intermittent Orc Incursion, Sir.")
		Turbine.Shell.WriteLine("To change the direction of fill type /WI rev. Thank you, Sir!")
		end
	if args=="keys" then ChangeKeys() end
	if args=="all" then Turbine.Shell.WriteLine("Displaying all Gambits of length "..WardenData.minsize.." or more, Sir! May be bigger than the display, Sir! This will disappear any time you press a key, Sir, so try not to be surpised...") IndiWindow:SetVisible (true)	ResetGambits() Display() end
	if args=="rev" then WardenData.reverse=not(WardenData.reverse) IndiWindow.DragBar:SetBarOnTop( not(WardenData.reverse) ) Turbine.PluginData.Save( Turbine.DataScope.Character, "WardenIndicator", WardenData ); end
	if args=="size" then 
		IconSize=IconSize+8
		if IconSize>32 then IconSize=16 end
		CreateFrames()
		WardenData.IconSize=IconSize
		Turbine.PluginData.Save( Turbine.DataScope.Character, "WardenIndicator", WardenData )
		Turbine.Shell.WriteLine("Size changed to "..IconSize.." Sir!")
	end
		
	if type(tonumber(args))=="number" then Turbine.Shell.WriteLine("Minimum gambit length set to "..args) WardenData.minsize=tonumber(args) LoadRawList() ResetGambits() Turbine.PluginData.Save( Turbine.DataScope.Character, "WardenIndicator", WardenData ) end
end
Turbine.Shell.AddCommand('WI', shellCommand)

--Create all the frames and lets go!
CreateFrames()